services:

    nsiws-demo-design:
        image: siscc/sdmxri-nsi-maapi:${NSI_IMAGE_TAG}
        container_name: nsiws-demo-design
        ports:
          - "${NSI_DESIGN_PORT}:80"
        environment:
            # Authentication configuration
            auth__enabled: ${AUTH_ENABLED}
            auth__allowAnonymous: "true"
            auth__authority: http://keycloak:8080/auth/realms/${KEYCLOAK_REALM}
            auth__clientId: ${KEYCLOAK_CLIENT_ID}
            auth__requireHttps: "false"
            auth__validateIssuer: "false"
            auth__showPii: "true"
            # Authorization configuration
            mappingStore__Id__Default: "demo-design" #Dataspace id
            DotStatSuiteCoreCommonDbConnectionString: Server=${MARIADB_SERVER_HOST};Database=${COMMON_DB};User=${COMMON_DB_RO_USER};Password=${COMMON_DB_RO_PWD};
            DbType: MariaDb
            # Database configuration
            SQL_SERVER: ${MARIADB_SERVER_HOST}
            SQL_DATABASE: ${STRUCT_DB_DESIGN}
            SQL_USER: ${STRUCT_DB_DESIGN_USER}
            SQL_PASSWORD: ${STRUCT_DB_DESIGN_PWD}
            SQL_PROVIDER: MySqlConnector
            # Dissemination database configuration
            disseminationDbConnection__dbType: MySQL
            disseminationDbConnection__connectionString: Server=${MARIADB_SERVER_HOST};Database=${DATA_DB_DESIGN};User=${DATA_DB_DESIGN_USER};Password=${DATA_DB_DESIGN_PWD};
            # MAAPI.NET configuration
            MA_SQL_USER: ${MARIADB_ROOT_USER}
            MA_SQL_PASSWORD: ${MARIADB_ROOT_PASSWORD}
            MA_ALWAYS_RESET: N
            # Other NSI WS configuration
            INSERT_NEW_ITEM_SCHEME_VALUES: "true"
            SENDER_ID: "demo-design-DotStatV8"
            enableReleaseManagement: "true"
            excludeNonCodedDimensionsDuringConstraintCalculation: "true"
        depends_on:
          dbup-struct-design:
            condition: service_completed_successfully
        volumes:
          - "./logs:/app/logs"
        networks:
          - dotstat_network

    nsiws-demo-release:
        image: siscc/sdmxri-nsi-maapi:${NSI_IMAGE_TAG}
        container_name: nsiws-demo-release
        ports:
          - "${NSI_RELEASE_PORT}:80"
        environment:
            # Authentication configuration
            auth__enabled: ${AUTH_ENABLED}
            auth__allowAnonymous: "true"
            auth__authority: http://keycloak:8080/auth/realms/${KEYCLOAK_REALM}
            auth__clientId: ${KEYCLOAK_CLIENT_ID}
            auth__requireHttps: "false"
            auth__validateIssuer: "false"
            auth__showPii: "true"
            # Authorization configuration
            mappingStore__Id__Default: "demo-release" #Dataspace id
            DotStatSuiteCoreCommonDbConnectionString: Server=${MARIADB_SERVER_HOST};Database=${COMMON_DB};User=${COMMON_DB_RO_USER};Password=${COMMON_DB_RO_PWD};
            DbType: MariaDb
            # Database configuration
            SQL_SERVER: ${MARIADB_SERVER_HOST}
            SQL_DATABASE: ${STRUCT_DB_RELEASE}
            SQL_USER: ${STRUCT_DB_RELEASE_USER}
            SQL_PASSWORD: ${STRUCT_DB_RELEASE_PWD}
            SQL_PROVIDER: MySqlConnector
            # Dissemination database configuration
            disseminationDbConnection__dbType: MySQL
            disseminationDbConnection__connectionString: Server=${MARIADB_SERVER_HOST};Database=${DATA_DB_RELEASE};User=${DATA_DB_RELEASE_USER};Password=${DATA_DB_RELEASE_PWD};
            # MAAPI.NET configuration
            MA_SQL_USER: ${MARIADB_ROOT_USER}
            MA_SQL_PASSWORD: ${MARIADB_ROOT_PASSWORD}
            MA_ALWAYS_RESET: N
            # Other NSI WS configuration
            INSERT_NEW_ITEM_SCHEME_VALUES: "true"
            SENDER_ID: "demo-release-DotStatV8"
            enableReleaseManagement: "true"
            excludeNonCodedDimensionsDuringConstraintCalculation: "true"
        depends_on:
          dbup-struct-release:
            condition: service_completed_successfully
        volumes:
          - "./logs:/app/logs"
        networks:
          - dotstat_network

    transfer-service:
        image: siscc/dotstatsuite-core-transfer:${TRANSFER_IMAGE_TAG}
        container_name: transfer-service
        environment:
            auth__Enabled: ${AUTH_ENABLED}
            auth__authority: http://keycloak:8080/auth/realms/${KEYCLOAK_REALM}
            auth__clientId: ${KEYCLOAK_CLIENT_ID}
            auth__authorizationUrl: http://${KEYCLOAK_HOST}:${KEYCLOAK_PORT}/auth/realms/${KEYCLOAK_REALM}/protocol/openid-connect/auth
            auth__scopes__0: openid
            auth__scopes__1: profile
            auth__scopes__2: email
            auth__claimsMapping__email: email
            auth__claimsMapping__groups: groups
            auth__requireHttps: "false"
            auth__validateIssuer: "false"
            MaxTransferErrorAmount: 0
            DefaultLanguageCode: en
            SmtpHost: ${SMTP_HOST}
            SmtpPort: ${SMTP_PORT}
            SmtpEnableSsl: ${SMTP_TLS}
            SmtpUserName: ${SMTP_USER}
            SmtpUserPassword: ${SMTP_PASSWORD}
            MailFrom: noreply@dlm.org
            MaxTextAttributeLength: 150
            ExcludeNonCodedDimensionsDuringConstraintCalculation: "true"
            DotStatSuiteCoreCommonDbConnectionString: Server=${MARIADB_SERVER_HOST};Database=${COMMON_DB};User=${COMMON_DB_RO_USER};Password=${COMMON_DB_RO_PWD};
            DbType: "MariaDb"
            SpacesInternal__0__Id: demo-design
            SpacesInternal__0__DotStatSuiteCoreStructDbConnectionString: Server=${MARIADB_SERVER_HOST};Database=${STRUCT_DB_DESIGN};User=${STRUCT_DB_DESIGN_USER};Password=${STRUCT_DB_DESIGN_PWD};
            SpacesInternal__0__DotStatSuiteCoreDataDbConnectionString: Server=${MARIADB_SERVER_HOST};Database=${DATA_DB_DESIGN};User=${DATA_DB_DESIGN_USER};Password=${DATA_DB_DESIGN_PWD};
            SpacesInternal__0__DataImportTimeOutInMinutes: 10
            SpacesInternal__0__DatabaseCommandTimeoutInSec: 60
            SpacesInternal__0__AutoLog2DB: "true"
            SpacesInternal__0__AutoLog2DBLogLevel: "Notice"
            SpacesInternal__0__DbType: "MariaDb"
            SpacesInternal__0__MySql__UseColumnstoreIndexes: "false"
            SpacesInternal__1__Id: demo-release
            SpacesInternal__1__DotStatSuiteCoreStructDbConnectionString: Server=${MARIADB_SERVER_HOST};Database=${STRUCT_DB_RELEASE};User=${STRUCT_DB_RELEASE_USER};Password=${STRUCT_DB_RELEASE_PWD};
            SpacesInternal__1__DotStatSuiteCoreDataDbConnectionString: Server=${MARIADB_SERVER_HOST};Database=${DATA_DB_RELEASE};User=${DATA_DB_RELEASE_USER};Password=${DATA_DB_RELEASE_PWD};
            SpacesInternal__1__DataImportTimeOutInMinutes: 10
            SpacesInternal__1__DatabaseCommandTimeoutInSec: 60
            SpacesInternal__1__AutoLog2DB: "true"
            SpacesInternal__1__AutoLog2DBLogLevel: "Notice"
            SpacesInternal__1__DbType: "MariaDb"
            SpacesInternal__1__MySql__UseColumnstoreIndexes: "false"
        volumes:
          - "./logs:/app/logs"
        ports:
          - "${TRANSFER_PORT}:80"
        depends_on:
          dbup-data-design:
            condition: service_completed_successfully
          dbup-struct-design:
            condition: service_completed_successfully
          dbup-data-release:
            condition: service_completed_successfully
          dbup-struct-release:
            condition: service_completed_successfully
        networks:
          - dotstat_network

    auth-service:
        image: siscc/dotstatsuite-core-auth-management:${AUTH_IMAGE_TAG}
        container_name: auth-service
        environment:
            auth__enabled: ${AUTH_ENABLED}
            auth__authority: http://keycloak:8080/auth/realms/${KEYCLOAK_REALM}
            auth__clientId: ${KEYCLOAK_CLIENT_ID}
            auth__authorizationUrl: http://${KEYCLOAK_HOST}:${KEYCLOAK_PORT}/auth/realms/${KEYCLOAK_REALM}/protocol/openid-connect/auth
            auth__scopes__0: openid
            auth__scopes__1: profile
            auth__scopes__2: email
            auth__claimsMapping__email: email
            auth__claimsMapping__groups: groups
            auth__requireHttps: "false"
            auth__validateIssuer: "false"
            DotStatSuiteCoreCommonDbConnectionString: Server=${MARIADB_SERVER_HOST};Database=${COMMON_DB};User=${COMMON_DB_USER};Password=${COMMON_DB_PWD};
            DbType: MariaDb
        volumes:
          - "./logs:/app/logs"
        ports:
          - "${AUTH_PORT}:80"
        depends_on:
          dbup-common:
            condition: service_completed_successfully          
        networks:
          - dotstat_network

    dbup-struct-design:
        image: siscc/dotstatsuite-dbup:${DBUP_IMAGE_TAG}
        container_name: dbup-struct-design
        environment:
            EXECUTION_PARAMETERS: upgrade --connectionString Server=${MARIADB_SERVER_HOST};Database=${STRUCT_DB_DESIGN};User=${MARIADB_ROOT_USER};Password=${MARIADB_ROOT_PASSWORD}; --mappingStoreDb --loginName ${STRUCT_DB_DESIGN_USER} --loginPwd ${STRUCT_DB_DESIGN_PWD} --force --alterPassword --useMariaDb
        depends_on:
          mariadb:
            condition: service_healthy
        networks:
          - dotstat_network

    dbup-data-design:
        image: siscc/dotstatsuite-dbup:${DBUP_IMAGE_TAG}
        container_name: dbup-data-design
        environment:
            EXECUTION_PARAMETERS: upgrade --connectionString Server=${MARIADB_SERVER_HOST};Database=${DATA_DB_DESIGN};User=${MARIADB_ROOT_USER};Password=${MARIADB_ROOT_PASSWORD}; --dataDb --loginName ${DATA_DB_DESIGN_USER} --loginPwd ${DATA_DB_DESIGN_PWD} --force --alterPassword --useMariaDb
        depends_on:
          mariadb:
            condition: service_healthy
        networks:
          - dotstat_network

    dbup-struct-release:
        image: siscc/dotstatsuite-dbup:${DBUP_IMAGE_TAG}
        container_name: dbup-struct-release
        environment:
            EXECUTION_PARAMETERS: upgrade --connectionString Server=${MARIADB_SERVER_HOST};Database=${STRUCT_DB_RELEASE};User=${MARIADB_ROOT_USER};Password=${MARIADB_ROOT_PASSWORD}; --mappingStoreDb --loginName ${STRUCT_DB_RELEASE_USER} --loginPwd ${STRUCT_DB_RELEASE_PWD} --force --alterPassword --useMariaDb
        depends_on:
          mariadb:
            condition: service_healthy
        networks:
          - dotstat_network

    dbup-data-release:
        image: siscc/dotstatsuite-dbup:${DBUP_IMAGE_TAG}
        container_name: dbup-data-release
        environment:
            EXECUTION_PARAMETERS: upgrade --connectionString Server=${MARIADB_SERVER_HOST};Database=${DATA_DB_RELEASE};User=${MARIADB_ROOT_USER};Password=${MARIADB_ROOT_PASSWORD}; --dataDb --loginName ${DATA_DB_RELEASE_USER} --loginPwd ${DATA_DB_RELEASE_PWD} --force --alterPassword --useMariaDb
        depends_on:
          mariadb:
            condition: service_healthy
        networks:
          - dotstat_network

    dbup-common:
        image: siscc/dotstatsuite-dbup:${DBUP_IMAGE_TAG}
        container_name: dbup-common
        environment:
            EXECUTION_PARAMETERS: upgrade --connectionString Server=${MARIADB_SERVER_HOST};Database=${COMMON_DB};User=${MARIADB_ROOT_USER};Password=${MARIADB_ROOT_PASSWORD}; --commonDb --loginName ${COMMON_DB_USER} --loginPwd ${COMMON_DB_PWD} --force --alterPassword --ROloginName ${COMMON_DB_RO_USER} --ROloginPwd ${COMMON_DB_RO_PWD} --useMariaDb
        depends_on:
          mariadb:
            condition: service_healthy
        networks:
          - dotstat_network

    mariadb:
        image: mariadb:11.4.3
        container_name: mariadb
        environment:
            MARIADB_ROOT_PASSWORD: ${MARIADB_ROOT_PASSWORD}
        command: --lower_case_table_names=1
        ports:
          - "${MARIADB_PORT}:3306"
        networks:
          - dotstat_network
        healthcheck:
          test: bash healthcheck.sh --su-mysql --connect --innodb_initialized 
          interval: 30s
          timeout: 10s
          retries: 3
          start_period: 10s
        volumes:
          - "mariadb-data:/var/lib/mysql"

volumes:
  mariadb-data:

networks:
  dotstat_network:
    name: dotstat_common_network
